=== debian/changelog ===
pd-pdogg (0.25.1-7) unstable; urgency=medium

  * Modernize 'licensecheck' target
    + Ensure that 'licensecheck' is run with the C.UTF-8 locale
    + Exclude debian/ from 'licensecheck'
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 07 Dec 2022 10:49:17 +0100

pd-pdogg (0.25.1-6) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Archive, Bug-Database.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 05 Dec 2022 12:27:48 +0100

pd-pdogg (0.25.1-5) unstable; urgency=medium

  * Modernize 'licensecheck' target
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 05 Dec 2022 10:58:52 +0100

pd-pdogg (0.25.1-4) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Make sure that CPPFLAGS are applied
  * Removed Hans-Christoph Steiner from Uploaders as he requested
  * Add salsa-ci configuration
  * Remove obsolete file d/source/local-options
  * Declare that building this package does not require 'root' powers.
  * Apply "warp-and-sort -ast"
  * Bump dh-compat to 13
  * Bump standards version to 4.6.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 04 Sep 2022 14:14:47 +0200

pd-pdogg (0.25.1-3) unstable; urgency=medium

  * Fixed spelling errors
  * Simplified & unified d/rules
    * Bumped dh compat to 11
    * Enabled hardening
  * Updated Vcs-* stanzas to salsa.d.o
  * Updated maintainer address
  * Switched URLs to https://
  * Removed trailing whitespace in debian/*
  * Updated d/copyright_hints
  * Bumped standards version to 4.1.3

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 01 Feb 2018 23:28:34 +0100

pd-pdogg (0.25.1-2) unstable; urgency=medium

  [ Hans-Christoph Steiner ]
  * Depends: puredata-core | pd, so the depends is not only on a virtual package
  * Updated to copyright-format/1.0
  * Removed 'DM-Upload-Allowed: yes', its deprecated

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Dropped obsolete add-required-header patch (Closes: #872677)
  * Demoted pd-libdir to Recommends
  * Dropped versioned dependency on debhelper
  * Added myself to uploaders
  * Updated Vcs-* stanzas
  * Updated upstream homepage to https://
  * Updated d/copyright
  * Bumped standards version to 4.1.0
  * Bumped dh compat to 9

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 23 Aug 2017 13:07:09 +0200

pd-pdogg (0.25.1-1) unstable; urgency=low

  [ IOhannes m zmölnig ]
  * New upstream (Closes: #609433)
  * Fixed capitalization of Ogg/Vorbis (Closes: #620994)
  * Removed explicit dependency on quilt

  [ Hans-Christoph Steiner ]
  * updated Build-Depends to use puredata-dev (Closes: #629701)
  * bumped standards version to 3.9.2

 -- Hans-Christoph Steiner <hans@eds.org>  Fri, 10 Jun 2011 14:42:39 -0400

pd-pdogg (0.25-1) unstable; urgency=low

  * Initial release (Closes: #591711)

 -- Hans-Christoph Steiner <hans@eds.org>  Wed, 10 Nov 2010 15:15:44 -0500
