=== debian/control ===
Source: pd-pdogg
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libvorbis-dev,
 pkg-config,
 puredata-dev | puredata (<< 0.43),
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://puredata.info
Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-pdogg.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/pd/pd-pdogg

Package: pd-pdogg
Architecture: any
Depends:
 puredata-core | pd,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 pd-libdir,
Description: collection of Ogg/Vorbis objects for Pd
 pdogg is a library of objects for Pd for reading and writing Ogg/Vorbis
 streams and files.  There is a stream player for multichannel audio streams
 and a streaming source client to send Ogg/Vorbis encoded audio streams over
 LAN or internet using JRoar, Icecast2 or PeerCast.  There are also objects
 for reading and writing Ogg/Vorbis files.
